  var remotedataurl = 'remotedata.php';
  var lastfind;
  var lastfragment;
  var filterhasfocus = false;
  var myAjax;

  function GetTickCount()
  {
    var now = new Date();
    return now.getTime();
  }
  
	function GetRemoteData(find, responseformat, replaceid, firstrun)
  {

    if (!firstrun)
    {
      if (lastfind === find)
      {
        return;
      }
      lastfind = find;

      if (myAjax)
      {
         myAjax.transport.abort();
      }
    } else
    {

    }

    Element.show('systemWorking');

    switch (responseformat)
    {
      case 'json'  : processfunction = ProcessJSONResponse; break;
      case 'csv'  : processfunction = ProcessCSVResponse; break;
      default : responseformat = 'xml';
      case 'xml'   : var processfunction = ProcessXMLResponse; break;
    }

		var pars = 'responseformat=' + responseformat + '&filter=' + encodeURIComponent(find) + '&nc=' + Math.random();

    requeststart = GetTickCount();
    myAjax = new Ajax.Request(
					remotedataurl,
					{
						method: 'get',
						parameters: pars,
						onComplete: processfunction,
						onFailure: reportError
					});

	}

  function SetRadioGroupValue(formname, radiogroupname, value)
  {
    radios = document.forms[formname].elements[radiogroupname];

    for (var i = 0, n = radios.length; i < n; i++)
    {
      var element = radios[i];
      element.checked = (element.tagName.toLowerCase() === 'input' && element.type === 'radio' && element.value == value);
        //element.checked = true;
    }
  }

  function GetRadioGroupValue(formname, radiogroupname)
  {
    radios = document.forms[formname].elements[radiogroupname];
    
    for (var i = 0, n = radios.length; i < n; i++)
    {
      var element = radios[i];
      if (element.tagName.toLowerCase() === 'input' && element.type === 'radio' && element.checked)
        return element.value;
    }
    
  }

  function MakeRowFromArray(cells)
  {
    var tagTR = document.createElement( "tr" );

    for (var i = 0, n = cells.length; i < n; i++)    
    {
      var tagTD = document.createElement( "td" );

      tagTR.appendChild( tagTD );
      tagTD.innerHTML = cells[i];
    }

    return tagTR;
  }
  
  function ArrayPushValueOrValue(thearray, value1, value2)
  {
    if (value1)
      thearray.push(value1)
    else
      {
        if (value2)
          thearray.push(value2);
        else
          thearray.push('');
      }
  }

  function IntroduceMitarbeiterData(tbody, mitarbeiter)
  {
    n = mitarbeiter.length;

    if (n < 1)
    {
      row = MakeRowFromArray(["Keine Mitarbeiter gefunden"]);
      row.firstChild.setAttribute('colSpan', 8);
      row.firstChild.setAttribute('class', 'center');
      tbody.appendChild(row);
    } else
    for (var i = 0; i < n; i++)
    {
      var person = mitarbeiter[i];

      var tabledata = new Array();

      if (person['url'])
      {
        tabledata.push('<a href="' + person['url'] + '">' + person['nachname'] + '</a>');
      } else
      {
        tabledata.push(person['nachname']);
      }

      ArrayPushValueOrValue(tabledata, person['vorname'], '');
      ArrayPushValueOrValue(tabledata, person['art']);
      ArrayPushValueOrValue(tabledata, person['titel']);

      if (person['email'])
      {
        tabledata.push('<a href="mailto:' + person['email'] + '@fh-wedel.de">' + person['email'] + '</a>');
      } else
      {
        tabledata.push('');
      }


      ArrayPushValueOrValue(tabledata, person['telefon']);
      ArrayPushValueOrValue(tabledata, person['fax']);
      ArrayPushValueOrValue(tabledata, person['raum']);

      var row = MakeRowFromArray(tabledata)

      if (i % 2 != 0)
        row.className = "alternate";

      tbody.appendChild(row);
    }


    var now = GetTickCount();
    UpdateStats((processstart - requeststart) + 'ms + ' + (now - processstart) + 'ms = ' + (now - requeststart) + 'ms');

    Element.hide('systemWorking');
  }

  function DeleteMitarbeiterData(tbody)
  {
    // Alle vorhandenen Zeilen löschen
    while (tbody.hasChildNodes())
    {
      tbody.removeChild(tbody.firstChild);
    }
  }

  function ProcessXMLResponse(originalRequest)
	{
	  processstart = GetTickCount();

    var mitarbeiter = Array();
    try
    {
      var mitarbeiterxml = originalRequest.responseXML.getElementsByTagName("mitarbeiter")[0].childNodes;

      for (var i = 0, n = mitarbeiterxml.length; i < n; i++)
      {
        var persondata = Object();
        var personxml = mitarbeiterxml[i].childNodes;
        for (var j = 0, m = personxml.length; j < m; j++)
        {
          var value = personxml[j].firstChild.nodeValue;
          if (value)
            persondata[personxml[j].nodeName] = value;
        }
        mitarbeiter.push(persondata);
      }
    }
    catch (e)
    {
      alert('Die empfangenen Daten konnten nicht verarbeitet werden.');
    }
    
    var tbody = $('daten');
    DeleteMitarbeiterData(tbody);
    IntroduceMitarbeiterData(tbody, mitarbeiter);

	}

  function ProcessJSONResponse(originalRequest)
	{
	  processstart = GetTickCount();
    try
    {
      var mitarbeiter = eval(originalRequest.responseText);
    }
    catch (e)
    {
      var mitarbeiter = Array();
    }

    var tbody = $('daten');
    DeleteMitarbeiterData(tbody);
    IntroduceMitarbeiterData(tbody, mitarbeiter);
	}

  function ProcessCSVResponse(originalRequest)
	{
	  processstart = GetTickCount();
    try
    {
      var mitarbeiter = Array();

      var lines = originalRequest.responseText.split("\r\n");
      var keys = lines[0].replace(/^\"/, '').replace(/\"$/, '').split('\";\"');

      for (i = 1; i < (lines.length - 1); i++)
      {

        var person = lines[i].replace(/^\"/, '').replace(/\"$/, '').split('\";\"');

        var persondata = Object();

        for (j = 0; j < person.length; j++)
        {
          persondata[keys[j]] = person[j];
        }
        mitarbeiter.push(persondata);
			}
    }
    catch (e)
    {
      var mitarbeiter = Array();
    }

    var tbody = $('daten');
    DeleteMitarbeiterData(tbody);
    IntroduceMitarbeiterData(tbody, mitarbeiter);
	}


  function reportError(request)
	{
		alert('Sorry. There was an error.');
	}
	
	function UpdateStats(stats)
  {

    if (!$('dauer'))
    {
      form = document.getElementsByName('parameter')[0];

      var div = document.createElement( "div" );

      div.innerHTML = '<span id="dauer"></span><br /><span id="formel">(XMLHTTPRequest + Verarbeitung = Gesamt)</span>';
      form.appendChild(div);
    }
    $('dauer').innerHTML = stats;
  }
	
	function ToggleElements()
	{
    Element.hide('suchen');
    caption = document.getElementsByTagName('caption', $('mitarbeiter'))[0];

    caption.innerHTML = caption.innerHTML + ' <span id="systemWorking" ><img src="loading.gif"> suche...</span>';

  }

  function SetStateFromFragment(fragment, setinputs)
  {

    var urlcommands = fragment.split(':');

    if (urlcommands.length == 3)
    {
      if (setinputs || !filterhasfocus)
      {
        $('filter').value = urlcommands[1];
        SetRadioGroupValue('parameter', 'responseformat', urlcommands[2]);
      }
      GetRemoteData(urlcommands[1], urlcommands[2], 'data', false);
    }
  }
  
  function ChangeFragment(find, responseformat)
  {
    window.location = '#find:' + find + ':' + responseformat;
  }
  
  function CheckURLFragment(setinputs)
  {
    if (lastfragment != window.location.hash)
    {
      lastfragment = window.location.hash;
      SetStateFromFragment(lastfragment, setinputs);
    }
    window.setTimeout(CheckURLFragment, 250);
  }
  
  function InitApp()
  {
    //alert('Loading now');
    ToggleElements();
    
    CheckURLFragment(true);

    var filter = $('filter');
    
    Event.observe(filter, 'keyup', function () { ChangeFragment(filter.value, GetRadioGroupValue('parameter', 'responseformat'));}, false);
    Event.observe(filter, 'focus', function () { filterhasfocus = true; }, false);
    Event.observe(filter, 'blur', function () { filterhasfocus = false; }, false);
  }
  
  try
  {
    Event.observe(window, 'load', InitApp, false);
  }
  catch(e)
  {
  }