<?php

  $is_included = count(get_included_files()) > 1;

  $responseformat = strtolower($_REQUEST['responseformat']);
  $find = strtolower($_REQUEST['filter']);

  if ($is_included || $responseformat == '')
    $responseformat = 'html';


  // die Daten der FH-Mitarbeiter, für dieses Beispiel
  // keine Datenbank, damit nur PHP benötigt wird.
  $fhdata = unserialize(file_get_contents('fhdata.txt'));
  

  // Welche Indizies sollen beim Filtern betrachtet werden
  $searchkeys = array();
  $searchkeys[] = 'nachname';
  $searchkeys[] = 'vorname';
  $searchkeys[] = 'email';

  $result = array();
  if ($find != '')
  {
    foreach ($fhdata as $row)
    {

      foreach ($row as $key => $value)
      {
        if (!in_array($key, $searchkeys))
          continue;

        #if (strpos(strtolower($value), $find) === 0)
        if (strpos(strtolower($value), $find) !== false)
        {
          $result[] = $row;
          break;
        }
      }
    }
  } else
    $result = $fhdata;

  switch ($responseformat)
  {
    case 'xml' :
      header('Content-type: text/xml; charset=utf-8');
      echo '<?xml version="1.0" encoding="utf-8" '.'?'.'>';

      echo '<mitarbeiter>';
      foreach ($result as $person)
      {
        echo '<person>';
        foreach ($person as $key => $value)
        {
          if ($value != '')
            echo '<'. $key .'><![CDATA['. $value .']]></'. $key .'>';
        }
        echo '</person>';
      }
      echo '</mitarbeiter>';

    	break;
    case 'json' :
      require_once('JSON.php');
      header('Content-type: application/json; charset=utf-8');
      $json = new Services_JSON();
      echo $json->encode($result);
      break;
    case 'csv' :
      header('Content-type: text/csv; charset=utf-8');

      $keys[] = 'art';
      $keys[] = 'nachname';
      $keys[] = 'url';
      $keys[] = 'vorname';
      $keys[] = 'titel';
      $keys[] = 'email';
      $keys[] = 'telefon';
      $keys[] = 'fax';
      $keys[] = 'raum';
      echo '"' . implode('";"', $keys) . '"'."\r\n";
      foreach ($result as $person)
      {
        $temp = array();
        foreach ($keys as $key)
        {
          if ($person[$key] != '')
            $temp[] = '"'.$person[$key] . '"';
          else
            $temp[] = '""';
        }
        echo implode(';', $temp) ."\r\n";
      }
    	break;
    default:
    case 'html' :
      $n = count($result);
      if ($n < 1)
      {
        echo '<tr><td colspan="8" class="center">Keine Mitarbeiter gefunden</td></tr>';
      } else
      for ($i=0; $i<$n; $i++)
      {
        $person = $result[$i];

        if ($i % 2 == 0)
          echo '<tr>';
        else
          echo '<tr class="alternate">';

        if ($person['url'] != '')
        {
          echo '<td><a href="'. $person['url'] .'">'. $person['nachname'] .'</a></td>';
        } else
        {
          echo '<td>'. $person['nachname'] .'</td>';
        }

        echo '<td>'. $person['vorname'] .'</td>';
        echo '<td>'. $person['art'] .'</td>';
        echo '<td>'. $person['titel'] .'</td>';
        if ($person['email'] != '')
        {
          echo '<td><a href="mailto:'. $person['email'] .'@fh-wedel.de">'. $person['email'] .'</a></td>';
        } else
        {
          echo '<td>'. $person['email'] .'</td>';
        }
        echo '<td>'. $person['telefon'] .'</td>';
        echo '<td>'. $person['fax'] .'</td>';
        echo '<td>'. $person['raum'] .'</td>';

        echo '</tr>';
      }
      break;

  }
  

?>
